diff --git a/test/unit/permission_test.rb b/test/unit/permission_test.rb
new file mode 100644
index 000000000..34379bdcb
--- /dev/null
+++ b/test/unit/permission_test.rb
@@ -0,0 +1,18 @@
+require 'test_helper'
+
+class PermissionTest < ActiveSupport::TestCase
+  test ".resources" do
+    Permission.resources.each {|r| assert_kind_of String, r }
+  end
+
+  test ".resources works even for undefined resource types" do
+    FactoryGirl.create :permission, :resource_type => 'SomethingNotExisting'
+    Permission.resources.each {|r| assert_not_nil r }
+  end
+
+  test ".resources_with_translations are ordered by translation" do
+    Permission.stubs(:with_translations).returns([['Z', 'z'], ['A', 'b'], ['H', 'a']])
+    assert_equal [['A', 'b'], ['H', 'a'], ['Z', 'z']], Permission.resources_with_translations
+  end
+
+end
diff --git a/test/unit/ptable_test.rb b/test/unit/ptable_test.rb
index dad934570..06e245584 100644
--- a/test/unit/ptable_test.rb
+++ b/test/unit/ptable_test.rb
@@ -81,67 +81,6 @@ class PtableTest < ActiveSupport::TestCase
     assert !partition_table.destroy
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_ptables"
-      role.permissions = ["#{operation}_ptables".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  Ptable.create :name => "dummy", :layout => "layout"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Ptable.create :name => "dummy", :layout => "layout"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  Ptable.first
-    as_admin do
-      record.hosts.delete_all
-      record.hostgroups.delete_all
-      assert record.destroy
-    end
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Ptable.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Ptable.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Ptable.first
-    record.name = "renamed"
-    as_admin do
-      record.hosts.destroy_all
-    end
-    assert !record.save
-    assert record.valid?
-  end
-
   test 'when creating a new ptable class object, an audit entry needs to be added' do
     as_admin do
       assert_difference('Audit.count') do
diff --git a/test/unit/puppetclass_test.rb b/test/unit/puppetclass_test.rb
index 184d2b4e2..2912bb8e6 100644
--- a/test/unit/puppetclass_test.rb
+++ b/test/unit/puppetclass_test.rb
@@ -27,84 +27,26 @@ class PuppetclassTest < ActiveSupport::TestCase
     assert !other_puppet_class.save
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_puppetclasses"
-      role.permissions = ["#{operation}_puppetclasses".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  Puppetclass.create :name => "dummy"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Puppetclass.create :name => "dummy"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  Puppetclass.first
-    as_admin do
-      record.hosts.destroy_all
-      record.lookup_keys.destroy_all
-    end
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Puppetclass.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Puppetclass.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Puppetclass.first
-    record.name = "renamed"
-    as_admin do
-      record.hosts.destroy_all
-    end
-    assert !record.save
-    assert record.valid?
-  end
-
   test "looking for a nonexistent host returns no puppetclasses" do
     assert_equal [], Puppetclass.search_for("host = imaginaryhost.nodomain.what")
   end
 
-  test "user without create external_variables permission cannot create smart variable for puppetclass" do
-    setup_user "edit"
-    nested_lookup_key_params = {:new_1372154591368 => {:key=>"test_param", :key_type=>"string", :default_value => "7777", :path =>"fqdn\r\nhostgroup\r\nos\r\ndomain"}}
-    refute Puppetclass.first.update_attributes(:lookup_keys_attributes => nested_lookup_key_params)
-  end
-
   test "user with create external_variables permission can create smart variable for puppetclass" do
     @one = users(:one)
     # add permission for user :one
     as_admin do
+      filter1 = FactoryGirl.build(:filter)
+      filter1.permissions = Permission.find_all_by_name(['create_external_variables'])
+      filter2 = FactoryGirl.build(:filter)
+      filter2.permissions = Permission.find_all_by_name(['edit_puppetclasses'])
       role = Role.find_or_create_by_name :name => "testing_role"
-      role.permissions = [:edit_puppetclasses, :create_external_variables]
-      @one.roles = [role]
+      role.filters = [ filter1, filter2 ]
+      role.save!
+      filter1.role = role
+      filter1.save!
+      filter2.role = role
+      filter2.save!
+      @one.roles = [ role ]
       @one.save!
     end
     as_user :one do
diff --git a/test/unit/report_test.rb b/test/unit/report_test.rb
index 9b220c323..8ada44761 100644
--- a/test/unit/report_test.rb
+++ b/test/unit/report_test.rb
@@ -64,46 +64,4 @@ class ReportTest < ActiveSupport::TestCase
     assert Report.with("pending").include?(@r)
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_reports"
-      role.permissions = ["#{operation}_reports".to_sym]
-      @one.roles = [role]
-      @one.save!
-      @r.save!
-    end
-    User.current = @one
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record = @r
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  @r
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should not be able to edit" do
-    # Reports are not an editable resource
-    setup_user "edit"
-    record        =  @r
-    record.status = {}
-    assert !record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record        =  @r
-    record.status = {}
-    assert !record.save
-    assert record.valid?
-  end
-
 end
diff --git a/test/unit/role_test.rb b/test/unit/role_test.rb
index ad95488e1..ddf5713e4 100644
--- a/test/unit/role_test.rb
+++ b/test/unit/role_test.rb
@@ -37,15 +37,6 @@ class RoleTest < ActiveSupport::TestCase
     role.wont_be :valid?
   end
 
-  it "should ensure length of name is at most 30" do
-    thirty = 'abcdefghijklmnopqrstuvwxyz1234'
-    thirtyone = 'abcdefghijklmnopqrstuvwxyz12345'
-    role = Role.new(:name => thirty)
-    role.must_be :valid?
-    role = Role.new(:name => thirtyone)
-    role.wont_be :valid?
-  end
-
   it "should allow value 'a role name' for name" do
     role = Role.new(:name => "a role name")
     role.must_be :valid?
@@ -66,25 +57,6 @@ class RoleTest < ActiveSupport::TestCase
     role.must_be :valid?
   end
 
-  def test_add_permission
-    role = Role.find(1)
-    size = role.permissions.size
-    role.add_permission!("apermission", "anotherpermission")
-    role.reload
-    assert role.permissions.include?(:anotherpermission)
-    assert_equal size + 2, role.permissions.size
-  end
-
-  def test_remove_permission
-    role = Role.find(1)
-    size = role.permissions.size
-    perm = role.permissions[0..1]
-    role.remove_permission!(*perm)
-    role.reload
-    assert ! role.permissions.include?(perm[0])
-    assert_equal size - 2, role.permissions.size
-  end
-
   context "System roles" do
     should "return the anonymous role" do
       role = Role.anonymous
@@ -97,6 +69,7 @@ class RoleTest < ActiveSupport::TestCase
         role_ids = Role.where("builtin = #{Role::BUILTIN_ANONYMOUS}").pluck(:id)
         user_ids = UserRole.where(:role_id => role_ids)
         UserRole.where(:role_id => role_ids).destroy_all
+        Filter.where(:role_id => role_ids).destroy_all
         Role.where(:id => role_ids).delete_all
       end
 
@@ -126,6 +99,7 @@ class RoleTest < ActiveSupport::TestCase
         role_ids = Role.where("builtin = #{Role::BUILTIN_DEFAULT_USER}").pluck(:id)
         user_ids = UserRole.where(:role_id => role_ids)
         UserRole.where(:role_id => role_ids).destroy_all
+        Filter.where(:role_id => role_ids).destroy_all
         Role.where(:id => role_ids).delete_all
       end
 
@@ -156,6 +130,64 @@ class RoleTest < ActiveSupport::TestCase
       it { subject.must_include(first) }
       it { subject.wont_include(second) }
     end
+  end
+
+  describe "#add_permissions" do
+    setup do
+      @permission1 = FactoryGirl.create(:permission, :name => 'permission1')
+      @permission2 = FactoryGirl.create(:permission, :architecture, :name => 'permission2')
+      @role = FactoryGirl.build(:role, :permissions => [])
+    end
+
+    it "should build filters with assigned permission" do
+      @role.add_permissions [@permission1.name, @permission2.name.to_sym]
+      assert @role.filters.all?(&:unlimited?)
+
+      permissions = @role.filters.map { |f| f.filterings.map(&:permission) }.flatten
+      assert_equal 2, @role.filters.size
+      assert_includes permissions, Permission.find_by_name(@permission1.name)
+      assert_includes permissions, Permission.find_by_name(@permission2.name)
+      # not saved yet
+      assert_empty @role.permissions
+    end
 
+    it "should raise error when given permission does not exist" do
+      assert_raises ArgumentError do
+        @role.add_permissions ['does_not_exist']
+      end
+    end
+
+    it "accespts one permissions instead of array as well" do
+      @role.add_permissions @permission1.name
+      permissions = @role.filters.map { |f| f.filterings.map(&:permission) }.flatten
+
+      assert_equal 1, @role.filters.size
+      assert_includes permissions, Permission.find_by_name(@permission1.name)
+    end
+
+    it "sets search filter to all filters" do
+      search = "id = 1"
+      @role.add_permissions [@permission1.name, @permission2.name.to_sym], :search => search
+      refute @role.filters.any?(&:unlimited?)
+      assert @role.filters.all? { |f| f.search == search }
+    end
+  end
+
+  describe "#add_permissions!" do
+    setup do
+      @permission1 = FactoryGirl.create(:permission, :name => 'permission1')
+      @permission2 = FactoryGirl.create(:permission, :architecture, :name => 'permission2')
+      @role = FactoryGirl.build(:role, :permissions => [])
+    end
+
+    it "persists built permissions" do
+      assert @role.add_permissions!([@permission1.name, @permission2.name.to_sym])
+      @role.reload
+
+      permissions = @role.permissions
+      assert_equal 2, @role.filters.size
+      assert_includes permissions, Permission.find_by_name(@permission1.name)
+      assert_includes permissions, Permission.find_by_name(@permission2.name)
+    end
   end
 end
diff --git a/test/unit/subnet_test.rb b/test/unit/subnet_test.rb
index 38e811bce..1b98a175d 100644
--- a/test/unit/subnet_test.rb
+++ b/test/unit/subnet_test.rb
@@ -86,70 +86,6 @@ class SubnetTest < ActiveSupport::TestCase
     @subnet.save!
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_subnets"
-      role.permissions = ["#{operation}_subnets".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record = Subnet.create :name => "dummy2", :network => "1.2.3.4", :mask => "255.255.255.0"
-    assert record.domain_ids = [Domain.first.id]
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Subnet.new :name => "dummy", :network => "1.2.3.4", :mask => "255.255.255.0"
-    assert record.valid?
-    assert !record.save
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record = subnets(:two)
-    as_admin do
-      record.domains.destroy_all
-      record.hosts.clear
-      record.interfaces.clear
-    end
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Subnet.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Subnet.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Subnet.first
-    record.name = "renamed"
-    as_admin do
-      record.domains = [domains(:unuseddomain)]
-    end
-    assert !record.save
-    assert record.valid?
-  end
-
   test "from cant be bigger than to range" do
     s      = subnets(:one)
     s.to   = "2.3.4.15"
diff --git a/test/unit/user_role_test.rb b/test/unit/user_role_test.rb
new file mode 100644
index 000000000..a85cb1005
--- /dev/null
+++ b/test/unit/user_role_test.rb
@@ -0,0 +1,85 @@
+require 'test_helper'
+
+class UserRoleTest < ActiveSupport::TestCase
+
+  def setup
+    User.current = User.find_by_login "admin"
+  end
+
+  test "type detection" do
+    user_role = FactoryGirl.create :user_user_role
+    assert user_role.user_role?
+    usergroup_role = FactoryGirl.create :user_group_user_role
+    assert usergroup_role.user_group_role?
+  end
+
+  test "cache user roles" do
+    user             = FactoryGirl.create :user
+    user_role        = FactoryGirl.create :user_user_role, :owner => user
+    cached_user_role = user.cached_user_roles.first
+
+    assert_equal user_role.role, cached_user_role.role
+    assert_equal user_role, cached_user_role.user_role
+  end
+
+  test "cache usergroup roles" do
+    user_role = setup_admins_scenario
+
+    users = @semiadmin_users + [@admin_user] + [@superadmin_user]
+    users.each do |user|
+      cached_user_role = user.cached_user_roles.first
+      assert_equal user_role.role, cached_user_role.role
+      assert_equal user_role, cached_user_role.user_role
+    end
+  end
+
+  test "update role of usergroup role" do
+    new_role = FactoryGirl.create :role
+    user_role = setup_admins_scenario
+    user_role.role = new_role
+    user_role.save
+
+    users = @semiadmin_users + [@admin_user] + [@superadmin_user]
+    users.each  do |user|
+      cached_user_role = user.cached_user_roles.first
+      assert_equal new_role, cached_user_role.role
+    end
+  end
+
+  test "update owner of usergroup role" do
+    user_role = setup_admins_scenario
+    user_role.owner = @admins
+    user_role.save
+
+    users = [@admin_user, @superadmin_user]
+    users.each do |user|
+      cached_user_role = user.cached_user_roles.first
+      assert_equal user_role.role, cached_user_role.role
+    end
+
+    users = @semiadmin_users
+    users.each do |user|
+      assert_empty user.cached_user_roles
+    end
+  end
+
+  def setup_admins_scenario
+    @semiadmins  = FactoryGirl.create :usergroup
+    @admins      = FactoryGirl.create :usergroup
+    @superadmins = FactoryGirl.create :usergroup
+
+    @semiadmins.usergroups = [@admins]
+    @admins.usergroups     = [@superadmins]
+
+    @semiadmin_users = [FactoryGirl.create(:user, :login => 'ur_semiadmin1'),
+                       FactoryGirl.create(:user, :login => 'ur_semiadmin2')]
+    @admin_user      = FactoryGirl.create(:user, :login => 'ur_admin1')
+    @superadmin_user = FactoryGirl.create(:user, :login => 'ur_superadmin1')
+
+    @semiadmins.users  += @semiadmin_users
+    @admins.users      = [@admin_user]
+    @superadmins.users = [@superadmin_user]
+
+    FactoryGirl.create :user_group_user_role, :owner => @semiadmins
+  end
+end
diff --git a/test/unit/user_test.rb b/test/unit/user_test.rb
index 4c0b256a2..b6592c7fc 100644
--- a/test/unit/user_test.rb
+++ b/test/unit/user_test.rb
@@ -127,14 +127,7 @@ class UserTest < ActiveSupport::TestCase
   end
 
   def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_users"
-      role.permissions = ["#{operation}_users".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
+    super operation, "users"
   end
 
   test "user with create permissions should be able to create" do
@@ -194,36 +187,6 @@ class UserTest < ActiveSupport::TestCase
     end
   end
 
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  User.new :login => "dummy", :mail => "j@j.com", :auth_source_id => AuthSourceInternal.first.id
-    record.password_hash = "asd"
-    assert !record.save
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  users(:one)
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  User.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      = users(:one)
-    record.login = "renamed"
-    assert record.save
-  end
-
   test "user cannot assign role he has not assigned himself" do
     setup_user "edit"
     extra_role      = Role.find_or_create_by_name :name => "foobar"
@@ -286,14 +249,6 @@ class UserTest < ActiveSupport::TestCase
     assert record.save
   end
 
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record       = users(:two)
-    record.login = 'renamed'
-    assert !record.save
-    assert record.valid?
-  end
-
   test "should not be able to rename the admin account" do
     u = User.find_by_login("admin")
     u.login = "root"
@@ -363,6 +318,27 @@ class UserTest < ActiveSupport::TestCase
     assert_equal user.role_ids_was, [foobar.id, barfoo.id]
   end
 
+  test "admin? detection for user admin flag" do
+    admin = FactoryGirl.build(:user, :admin => true)
+    assert admin.admin?, 'user admin flag was missed'
+  end
+
+  test "admin? detection for group admin flag" do
+    admin = FactoryGirl.build(:user)
+    g1 = FactoryGirl.build(:usergroup)
+    g2 = FactoryGirl.build(:usergroup, :admin => true)
+    admin.cached_usergroups = [g1, g2]
+    assert admin.admin?, 'group admin flag was missed'
+  end
+
+  test "admin? is false if no flag is enabled" do
+    admin = FactoryGirl.build(:user)
+    g1 = FactoryGirl.build(:usergroup)
+    g2 = FactoryGirl.build(:usergroup)
+    admin.cached_usergroups = [g1, g2]
+    refute admin.admin?
+  end
+
   test ".find_or_create_external_user" do
     count = User.count
     # existing user
@@ -443,4 +419,16 @@ class UserTest < ActiveSupport::TestCase
     assert_not User.current.editing_self?(options)
   end
 
+  test "#can? for admin" do
+    Authorizer.any_instance.stubs(:can?).returns(false)
+    u = FactoryGirl.build(:user, :admin => true)
+    assert u.can?(:view_hosts_or_whatever_you_ask)
+  end
+
+  test "#can? for not admin" do
+    Authorizer.any_instance.stubs(:can?).returns('authorizer was asked')
+    u = FactoryGirl.build(:user)
+    assert_equal 'authorizer was asked', u.can?(:view_hosts_or_whatever_you_ask)
+  end
+
 end
